PROGRAM montecarlo
 IMPLICIT NONE
 DOUBLE PRECISION x(0:9999), x_neu(0:9999)
 DOUBLE PRECISION ran2
 DOUBLE PRECISION o, E, P
 DOUBLE PRECISION h !Schrittweite
 DOUBLE PRECISION r
 DOUBLE PRECISION o_quer, integral
 INTEGER I, D, o_count, j, runs, warmups, k
 INTEGER iseed
 iseed = -int(time())
 runs = 10000000
 warmups = 100000
 D = 200
 x = 0D0 !Alle Elemente auf 0
 o_quer = 0d0
 o_count = 0
 h = 1D0/DSQRT(2D0)
 DO j = 0, runs
   I = ran2(iseed)*D
   !DO I = 0, D - 1 
   IF (.TRUE.) THEN
    DO k = 0,D - 1
      x_neu(k) = x(k)
    END DO
    x_neu(I) = x(I) + (ran2(iseed) - 0.5D0)*h
    r = P(x_neu, D)/P(x, D)
    IF (ran2(iseed) .LE. dmin1(1D0, r)) THEN
     x(I) = x_neu(I)
    END IF
    IF (j .GE. warmups) THEN
     o_quer = o_quer + o(x, D)
     o_count = o_count + 1
    END IF
   END IF
 END DO
 o_quer = o_quer/o_count
 WRITE (*,*) "o_quer = ", o_quer
 integral = o_quer
 WRITE (*,*) "Integral = ", integral
 
END

DOUBLE PRECISION FUNCTION o(x, D) RESULT(result)
 DOUBLE PRECISION x(0:9999)
 INTEGER I, D
 result = 0D0
 DO I = 0, D - 1
  result = result + x(I)*x(I)
 END DO
END

DOUBLE PRECISION FUNCTION E(x, D) RESULT(result)
 DOUBLE PRECISION x(0:9999)
 INTEGER I, D
 result = 0D0
 DO I = 0, D - 1
  result = result + x(I)*x(I)
 END DO
END

DOUBLE PRECISION FUNCTION P(x, D) RESULT(result)
 DOUBLE PRECISION x(0:9999)
 DOUBLE PRECISION E
 DOUBLE PRECISION beta
 INTEGER D
 beta = 1D0
 result = DEXP(-beta*E(x, D))
END
