recursive function ran2(idum)

implicit none
double precision :: ran2
integer, intent(inout) :: idum
integer j, k
integer :: idum2 = 123456789, iy = 0
integer, parameter :: im1=2147483563,im2=2147483399,imm1=im1-1
integer, parameter :: ia1=40014,ia2=40692,iq1=53668,iq2=52774
integer, parameter :: ir1=12211,ir2=3791,ntab=32,ndiv=1+imm1/ntab
integer, dimension(ntab) :: iv=0
double precision, parameter :: am=1.d0/im1, eps=1.2d-16, rnmx=1.d0-eps

if (idum <= 0) then                          ! initialize ran2
   idum = max(-idum,1)
   idum2 = idum
   do j=ntab+8,1,-1
      k = idum/iq1
      idum = ia1*(idum-k*iq1)-k*ir1
      if (idum < 0) idum = idum+im1
      if (j <= ntab) iv(j) = idum
   end do
   iy = iv(1)
end if

k = idum/iq1
idum = ia1*(idum-k*iq1)-k*ir1
if (idum < 0) idum = idum+im1
k = idum2/iq2
idum2 = ia2*(idum2-k*iq2)-k*ir2
if (idum2 < 0) idum2 = idum2+im2
j = 1+iy/ndiv
iy = iv(j)-idum2
iv(j) = idum
if (iy < 1) iy = iy+imm1
ran2 = min(am*iy,rnmx)

end function ran2
