FUNCTION f(x) RESULT (result)
    implicit none
    double precision x
    double precision result
    result = exp(-x)*(x + 3)
END

FUNCTION trapezIntegrate(a, b, h) result (Summe)
    implicit none
    integer j, n
    double precision a, b, v, h, x, Summe, f
    ! intervall(a,b) von f(x)
    Summe=0.0d0
    !        n=1000000
    !        h=(b - a)/n
    ! h :: Schrittweite
    ! n :: Anzahl Unterteilungen
    n=(b - a)/h
    do j=0,n-1
      x=a + j*h
      v=(b - a)*(f(x) + f(x + h))/(2*n)
      Summe=Summe + v
      !write(*,*) 'Summe= ',Summe
    end do
END

PROGRAM xyz
    implicit none
    double precision a, b, h, denominator, trapezIntegrate
    double precision I1
    double precision I2
    double precision I
    double precision pi
    pi = 4d0*atan(1d0)
    a = 0d0
    b = 9999999d0
    h = (b - a)
    I1 = trapezIntegrate(a, b, h)
    denominator = 2d0
    do while (1==1)
        h = (b - a)/denominator   
        !WRITE (*,*) h
        I2 = trapezIntegrate(a, b, h)
        I = (4d0*I2 - I1)/3d0
        IF (DABS((I - I2)/I2) .lt. 0.001d0) THEN
            EXIT
        END IF
        I1 = I2
        denominator = denominator*2
    end do
    WRITE(*,*) I2
END

