FUNCTION f(x) RESULT (result)
    implicit none
    double precision x
    double precision result
    result = exp(-x)*(x + 3)
END

PROGRAM xyz
    implicit none
    double precision, parameter :: a = 0.0d+00
    double precision abserr
    double precision, parameter :: epsabs = 0.0d+00
    double precision, parameter :: epsrel = 0.001d+00
    double precision, external :: f
    double precision, parameter :: b = 1000d0
    integer NSEG
    double precision result
    NSEG = 1
    CALL DADAPT(f,a,b,NSEG,epsrel,epsabs,result,abserr)
    WRITE(*,*) result
    WRITE(*,*) abserr
END

