PROGRAM trapezintegration
 IMPLICIT NONE
 INTEGER j, n, m
 DOUBLE PRECISION a, b, Summe, dx, I1, I2, I, Idiff, x, pi, f, v, Ialt
 DOUBLE PRECISION Ineu
 pi = 4d0*ATAN(1d0)
 a = 0
 b = 2*pi
 n = 100
 Ialt = (f(a) + f(b))*1d0/2d0
 I1 = (b - a)*Ialt
 Summe = 0.0
 
 do j=2, n, 1
   !IF (j == 1) THEN
     !dx = b - a
   !ELSE
     dx = (b - a)/(2d0*(j-1)) 
     do m=1, j, 1
       x = a + m*dx
       Summe = Summe + f(x)
     end do
   !END IF
   Ineu = (Ialt + Summe)
   !IF (j == 1) THEN
     !I1 = dx*Ialt
   !ELSE
     I1 = 2d0*dx*Ialt
   !END IF
   I2 = dx*Ineu
   I = 1d0/3d0*(4d0*I2 - I1)
   Idiff = DABS(I-I2)
   write(*,*) 'dx= ', dx
   write(*,*) 'I1= ',I1, 'I2= ', I2, 'I= ', I, 'Idiff= ', Idiff
   IF ((DABS(I - I2)) .gt. (1d0/1d2)) THEN 
     Ialt = Ineu
   ELSE
     exit
   END IF
 end do
 
END

DOUBLE PRECISION FUNCTION f(x) !zu integrierende Funktion
 DOUBLE PRECISION x
 f = exp(x)*cos(x)
END


