PROGRAM brown
  IMPLICIT NONE
  INTEGER iseed
  INTEGER J, N, K
  INTEGER stepcount
  DOUBLE PRECISION distance
  DOUBLE PRECISION distances(10000), temp(10000)
  REAL avdistances2(10000)
  REAL Ks(10000)
  REAL X
  REAL R
  stepcount = 10000
  iseed = -int(time())
  N = 3 !Grad des Fitpolynoms + 1
  DO K=1,10000,1
    distances(K) = 0D0
    Ks(K) = K
  END DO 
  DO J = 1,1000,1
    !DSQRT(100D0), 
    CALL walk(iseed, stepcount, temp)
    DO K=1,10000,1
        distances(K)=distances(K)+temp(K)
    END DO
    !WRITE(*,*) distance
  END DO
  DO K = 1,10000,1
    avdistances2(K)=REAL((distances(K)/1000D0)**2)
  END DO
  ! TODO lineare regression von avdistances2
  !X = 0.0E0
  !WRITE(*,*) ""
  !WRITE(*,*) ""
  !DO WHILE (X < 10000.0E0)
  !  CALL POLINT(Ks,avdistances2,N,X,R)
  !  WRITE(*,*) R, X
  !  X = X + 10E0
  !END DO
END

SUBROUTINE walk(iseed, stepcount, distances)
  IMPLICIT NONE
  INTEGER stepcount
  INTEGER I
  INTEGER iseed
  DOUBLE PRECISION X
  DOUBLE PRECISION R
  DOUBLE PRECISION Y
  DOUBLE PRECISION ran2
  DOUBLE PRECISION distances(10000)
  X = 0D0
  Y = 0D0
  DO I = 1,stepcount,1
    R = 2D0*3.141592D0*ran2(iseed)
    X = X + cos(R)
    Y = Y + sin(R)
    distances(I)=SQRT(X**2+Y**2)
    WRITE(*,*) I, SQRT(DBLE(I)), SQRT(X**2+Y**2)
  END DO
  !RESULT = DSQRT(X**2+Y**2)
END

