#!/usr/bin/env python
# Tridiagonale Matrizen loesen
from __future__ import division
def y(tau, inhomogenity, I):
  if (I == 0):
    return inhomogenity[I]
  else:
    return inhomogenity[I] - kappa(tau, I)*y(tau, inhomogenity, I - 1)
def solveLinearEquation(tau, inhomogenity, I):
  return y(tau, inhomogenity, I)/d(tau, I)
def kappa(tau, I):
  diagLower = -tau*0.5j
  return  diagLower/d(tau, I - 1)
def d(tau,I):
  diagUpper = -tau*0.5j
  diagMain = 1 - tau*(1j)
  if (I == 0):
    return diagMain
  else:
    return diagMain - kappa(tau, I)*diagUpper
