C23456789012345678901234567890123456789012345678901234567890123456789012
      PROGRAM NEUM
      implicit double precision (a-h,o-z)

      parameter(maxl=9)
      dimension fneum(0:maxl)

      open(1,FILE='neum.txt')
      step=0.1
      nstep=200
      x=1.
      do i=0,nstep
       x=x+step
       CALL SPHNEUM(x,maxl,fneum)
       write(1,'(F6.2,10G13.5)')x,fneum
      end do
      END
      
      SUBROUTINE SPHNEUM(X,LL,fneum)
      implicit double precision (a-h,o-z)

      dimension fneum(0:LL)
      
      if (x.eq.0) then
       STOP " X=0 in Neumann"
      end if

      fneum(0)=cos(x)/x
      fneum(1)=-(sin(x) + cos(x)/x)/x
      do l=2,ll
        fneum(l)=fneum(l-1)*(2*l-1)/x-fneum(l-2)
      end do
      
      RETURN
      END
